;   83C51F processor subrautine definition file
;   ================================
; 81C51FB  IROM  16K (0000h - 3FFFFh), 0EFFh, 
;      0F00h - ....

	CSEG	AT 0F00H
; ============= SUB =========================	
; SADC = SADC1 -   . OUT: ACC
;
;SPACE -       
;
;CR_ =CRLF1 -         
;
;CO -      .
;
;TXT_PRN = TXTOUT -       ASCIIZ.
;
;PRN_HEX = AHEX1 -    ACC   ASCII   .
;                              DST: R5, A, 
;
;INIT_SERIAL =  UART    

SADC1:  ;     2
	SETB	P3.4	;SAM=1
        SETB    P1.7
        NOP
        JNB     INT1,SADC40	;  int1=0,   
        CLR     P1.7		;  int1=1,   
sadc40:
        SETB    P1.6
        NOP
        JNB     INT1,SADC20
        CLR     P1.6
sadc20:
        SETB    P1.5
        NOP
        JNB     INT1,SADC10
        CLR     P1.5
sadc10:
        SETB    P1.4
        NOP
        JNB     INT1,SADC08
        CLR     P1.4
sadc08:
        SETB    P1.3
        JNB     INT1,SADC04
        CLR     P1.3
sadc04:
        SETB    P1.2
        NOP
        JNB     INT1,SADC02
        CLR     P1.2
sadc02:
        SETB    P1.1
        NOP
        JNB     INT1,SADC01
        CLR     P1.1
sadc01:
        SETB    P1.0
        NOP
        JNB     INT1,SADC00
        CLR     P1.0
SADC00:
        MOV     A,P1
        CLR	P3.4	;SAM=0
                RET	
space:
	MOV	A,#20H
	CALL	CO
	RET
	
		;cr_:
crlf1:
	MOV	A,#0DH
	CALL	CO
	RET
	
co:
	;    
	
	;          TI
	mov	SBUF,A	;  
	JNB	TI,$	;   " "
	CLR	TI	;   	
	RET
	
		;txt_prn:
txtout:
	; dptr -  
	; dst - A,F, r5
	MOV	R5,#0
	
txt_prn1:
	MOV	A,R5
	MOVC	A,@A+DPTR
	CJNE	A,#0,TXT_PRN2
	RET	

txt_prn2:
	CALL	CO
	INC	R5
	JMP	TXT_PRN1	
	
;prn_hex:
ahex1:
;   hex-  SP   
; HEX-  
; dst - A,F, R5, 
        MOV     R5,A
        SWAP    A       ;   .  . 
        CALL    TRNF_HEX1
        CALL	CO
        MOV     A,R5
        CALL    TRNF_HEX1
        CALL	CO
        RET

trnf_hex1:
 ;  .     ASCII-
; dst: acc, f
        CLR     C
        ANL     A,#0FH  ; . 
        SUBB    A,#0AH  ;  -
        JC      DIGIT2
        ADD     A,#(37H+0AH)    ;   ASCII  
        SJMP    _EXIT
digit2:
        ADD     A,#(30H+0AH)     ;   ASCII  
_exit:
        RET
        
 init_serial:
;  UART                
;Mode				= 1/8-bit UART
;Serial Port Interrupt		= Disabled
;Receive			= Enabled
;Auto Addressing		= Disabled
;     CO !!!
     mov SCON, #050h
;Timer 2 is being used to generate baud rates.
     mov RCAP2L, #0D9h
     mov RCAP2H, #0FFh
     mov T2CON, #034h
     CLR RI              ;SCON.0
     clr	TI
     ret       